VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "MenuContainer"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Description = "Embeds an menubar/submenu/popup menu structure"
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Member0" ,"MenuContainerOwnerDrawing"
Attribute VB_Ext_KEY = "Top_Level" ,"No"
Attribute VB_Ext_KEY = "Member1" ,"MenuItems"
Option Explicit

'==================================================================
'
' Menu Container Class
'
' 1 October 2001
'
' You're free in using this software, as long as the
' orignal copyright/author information remains intact.
' In other words, respecting the person(s) who made it
' possible for you to view/learn something of this software.
'
' Copyright  2001 - Diederik van der Boor
' http://www.codingdomain.com
'
' Important Note: *NEVER* re-compile the source code
' in it's current state. If you want to do that,
' please change the name of the project, and give the DLL
' an other filename then used. Actuallty, I would prefer
' you e-mail me the changes, so I release a new version of the DLL.
'
' Otherwise, some projects using the original DLL
' fail to run or crash at startup.
'
'==================================================================


'------------------------------------------------------------------------
' Declarations

Private CurhMenu As OLE_HANDLE
Private CurInherit As Boolean
Private CurMenus As MenuItems
Private CurOwnsHandle As Boolean
Private CurOwnDraw As MenuContainerOwnerDrawing
Private CurBrushBack As GDIObjects.GDIBrush

'------------------------------------------------------------------------
' Class interface: Attach and destroy a menu

Friend Sub Class_InitProps(ByVal hMenu As OLE_HANDLE)
  CurhMenu = hMenu
  Set CurMenus = New MenuItems
  Set CurOwnDraw = New MenuContainerOwnerDrawing
  Call CurMenus.Class_InitProps(CurhMenu)
End Sub

Private Sub Class_Terminate()
  If IsMenu(CurhMenu) <> 0 And CurOwnsHandle Then
    If DestroyMenu(CurhMenu) = 0 Then Call RaiseVBDLLError(SRC_CLASS_MENU & "Class_Terminate" & SRC_FUNCTION, ERR_FAIL_DLLCALL & "Failed to destroy menu!")
  End If
End Sub

'------------------------------------------------------------------------
' Class interface: Object Owns handle? (means has full control)

Public Property Get OwnsHandle() As Boolean
Attribute OwnsHandle.VB_Description = "If true, the object can destroy it's handle."
  OwnsHandle = CurOwnsHandle
End Property

Public Property Let OwnsHandle(ByVal NewValue As Boolean)
  CurOwnsHandle = NewValue
End Property

'------------------------------------------------------------------------
' Class interface: The menu-handle it embeds

Public Property Get hMenu() As OLE_HANDLE
Attribute hMenu.VB_Description = "Returns the windows handle to the popup menu."
Attribute hMenu.VB_UserMemId = 0
  hMenu = CurhMenu
End Property

Public Property Get Menus() As MenuItems
Attribute Menus.VB_Description = "Contains the menus inside this popup menu."
  Set Menus = CurMenus
End Property

'------------------------------------------------------------------------
' Class interface: What happens when settings are changed

Public Property Get InheritSettings() As Boolean
Attribute InheritSettings.VB_Description = "If true, some changing settings will affect submenus aswell."
  InheritSettings = CurInherit
End Property

Public Property Let InheritSettings(ByVal NewValue As Boolean)
  CurInherit = NewValue
End Property

'------------------------------------------------------------------------
' Reference to object containing more information, which is used when
' this DLL takes over all the painting of the menu item.

Public Property Get DrawExtras() As MenuContainerOwnerDrawing
Attribute DrawExtras.VB_Description = "Contains extra parameters used when a menu item in the menu is an owner-drawn menu."
  Set DrawExtras = CurOwnDraw
End Property


'------------------------------------------------------------------------
' Standard menu properties

Public Property Get MaxHeight() As Long
Attribute MaxHeight.VB_Description = "Returns/Sets the maximum height for the menu item."
  MaxHeight = Menu_GetInfo(CurhMenu, MIM_MAXHEIGHT).cyMax
End Property

Public Property Let MaxHeight(ByVal NewValue As Long)
  Dim Info As MENUINFO
  Info.cbSize = LenB(Info)
  Info.fMask = MIM_MAXHEIGHT Or IIf(CurInherit, MIM_APPLYTOSUBMENUS, 0)
  Info.cyMax = NewValue
  If SetMenuInfo(CurhMenu, Info) = 0 Then Call RaiseVBDLLError(SRC_CLASS_MENU & "MaxHeight" & SRC_PROP_LET, ERR_FAIL_SET)
End Property

Public Property Get HelpContextID() As Long
Attribute HelpContextID.VB_Description = "Returns/Sets the Help Context ID assiociated with the popup menu."
  HelpContextID = Menu_GetInfo(CurhMenu, MIM_HELPID).dwContextHelpID
End Property

Public Property Let HelpContextID(ByVal NewValue As Long)
  Dim Info As MENUINFO
  Info.cbSize = LenB(Info)
  Info.fMask = MIM_HELPID Or IIf(CurInherit, MIM_APPLYTOSUBMENUS, 0)
  Info.dwContextHelpID = NewValue
  If SetMenuInfo(CurhMenu, Info) = 0 Then Call RaiseVBDLLError(SRC_CLASS_MENU & "HelpContextID" & SRC_PROP_LET, ERR_FAIL_SET)
End Property

Public Property Get BackBrush() As GDIObjects.GDIBrush
Attribute BackBrush.VB_Description = "Contains the brush used for drawing the background."
  Dim hBrBack As OLE_HANDLE
  hBrBack = Menu_GetInfo(CurhMenu, MIM_BACKGROUND).hBrBack
  If Not CurBrushBack Is Nothing Then
    If hBrBack <> CurBrushBack.hBrush Then Set CurBrushBack = GDIObjects.GDIAttachBrush(hBrBack)
  Else
    Set CurBrushBack = GDIObjects.GDIAttachBrush(hBrBack)
  End If
  Set BackBrush = CurBrushBack
End Property

Public Property Set BackBrush(ByVal NewValue As GDIObjects.GDIBrush)
  Dim Info As MENUINFO
  If Not NewValue Is Nothing Then
    If Not TypeOf NewValue Is GDIObjects.GDIBrush Then Error 380
    Info.hBrBack = NewValue.hBrush
  End If
  Info.cbSize = LenB(Info)
  Info.fMask = MIM_BACKGROUND Or IIf(CurInherit, MIM_APPLYTOSUBMENUS, 0)
  If SetMenuInfo(CurhMenu, Info) = 0 Then Call RaiseVBDLLError(SRC_CLASS_MENU & "BackBrush" & SRC_PROP_LET, ERR_FAIL_SET)
  Set CurBrushBack = NewValue
End Property

Public Property Get Style() As MenuStyles
Attribute Style.VB_Description = "Returns/Sets the style of the popup menu."
  Style = Menu_GetInfo(CurhMenu, MIM_STYLE).dwStyle
End Property

Public Property Let Style(ByVal NewValue As MenuStyles)
  Dim Info As MENUINFO
  Info.cbSize = LenB(Info)
  Info.fMask = MIM_STYLE Or IIf(CurInherit, MIM_APPLYTOSUBMENUS, 0)
  Info.dwStyle = NewValue
  If SetMenuInfo(CurhMenu, Info) = 0 Then Call RaiseVBDLLError(SRC_CLASS_MENU & "Style" & SRC_PROP_LET, ERR_FAIL_SET)
End Property

'------------------------------------------------------------------------
' Display the menu (if popup), and attach window as parent to it.

Public Function Popup(ByVal hWndOwner As OLE_HANDLE, Optional ByVal Flags As MenuPopupFlags = mnuPopupRightBtnClose, Optional ByVal X As Long, Optional ByVal Y As Long) As Long
Attribute Popup.VB_Description = "Displays the menu as a popup menu."
  If IsWindow(hWndOwner) = 0 Then Call RaiseVBDLLError(SRC_CLASS_MENU & "Popup" & SRC_FUNCTION, ERR_ARGUMENT & "hWnd!")
  If (Flags And mnuPopupRecursePopupMenus) = 0 Then Call EndMenu
  Popup = TrackPopupMenu(CurhMenu, Flags, X, Y, 0, hWndOwner, ByVal 0&)
  If Popup = 0 And (Flags And mnuPopupReturnID) = 0 Then Call RaiseVBDLLError(SRC_CLASS_MENU & "Popup" & SRC_FUNCTION, "Failed to open popup menu!")
End Function

Public Function PopupEx(ByVal hWndOwner As OLE_HANDLE, Optional ByVal Flags As MenuPopupFlags = mnuPopupRightBtnClose, Optional ByVal X As Long, Optional ByVal Y As Long, Optional ByVal NoOverlapX1 As Long, Optional ByVal NoOverlapY1 As Long, Optional ByVal NoOverlapX2 As Long, Optional ByVal NoOverlapY2 As Long) As Long
Attribute PopupEx.VB_Description = "Displays the menu as a popup menu, advanced parameter version."
  If IsWindow(hWndOwner) = 0 Then Call RaiseVBDLLError(SRC_CLASS_MENU & "PopupEx" & SRC_FUNCTION, ERR_ARGUMENT & "hWnd!")
  Dim Params As TPMPARAMS
  Params.cbSize = LenB(Params)
  Params.rcExclude.Left = NoOverlapX1
  Params.rcExclude.Top = NoOverlapY1
  Params.rcExclude.Right = NoOverlapX2
  Params.rcExclude.Bottom = NoOverlapY2
  If (Flags And mnuPopupRecursePopupMenus) = 0 Then Call EndMenu
  PopupEx = TrackPopupMenuEx(CurhMenu, Flags, X, Y, hWndOwner, Params)
  If PopupEx = 0 And (Flags And mnuPopupReturnID) = 0 Then Call RaiseVBDLLError(SRC_CLASS_MENU & "PopupEx" & SRC_FUNCTION, "Failed to open popup menu with exclude option!")
End Function

'------------------------------------------------------------------------
' Check radio helper

Public Sub CheckRadio(ByVal FirstItem As MenuItem, ByVal LastItem As MenuItem, ByVal CheckedItem As MenuItem)
Attribute CheckRadio.VB_Description = "Checks and unchecks radio menu items."
  If CheckMenuRadioItem(CurhMenu, FirstItem.ID, FirstItem.ID, FirstItem.ID, MF_BYCOMMAND) = 0 Then Call RaiseVBDLLError(SRC_CLASS_MENU & "CheckRadio" & SRC_SUB, ERR_FAIL_DLLCALL & "Failed to check radio items!")
End Sub

'------------------------------------------------------------------------
' Setting the default item for a menu:

Public Sub SetDefaultItem(Optional ByVal Index As Long, Optional ByVal IndexType As MenuItemIndexType = mnuItemByID)
Attribute SetDefaultItem.VB_Description = "Sets the default item for the current menu."
  If IndexType = mnuItemByPosition Then Index = Index - 1
  If SetMenuDefaultItem(CurhMenu, Index, IIf(IndexType = mnuItemByPosition, 1, 0)) = 0 Then Call RaiseVBDLLError(SRC_CLASS_MENU & "SetDefaultItem" & SRC_SUB, ERR_FAIL_DLLCALL & "Failed to set default item!")
End Sub

Public Function GetDefaultItem(ByVal RetreivalIndexType As MenuItemIndexType, Optional ByVal Flags As MenuGetDefaultItemFlags) As Long
Attribute GetDefaultItem.VB_Description = "Returns the default menu item. (Commonly drawn with a bold font)."
  Dim Item As Long
  GetDefaultItem = GetMenuDefaultItem(CurhMenu, (RetreivalIndexType = mnuItemByPosition), Flags)
  If GetDefaultItem = -1 Then Call RaiseVBDLLError(SRC_CLASS_MENU & "GetDefaultItem" & SRC_FUNCTION, ERR_FAIL_DLLCALL & "Failed to get default menu item!")
  If RetreivalIndexType = mnuItemByPosition Then GetDefaultItem = GetDefaultItem + 1
End Function
