Attribute VB_Name = "MenuDeclarations"
Option Explicit

'==================================================================
'
' MenuBar Declarations
'
' 1 October 2001
'
' You're free in using this software, as long as the
' orignal copyright/author information remains intact.
' In other words, respecting the person(s) who made it
' possible for you to view/learn something of this software.
'
' Copyright  2001 - Diederik van der Boor
' http://www.codingdomain.com
'
' Important Note: *NEVER* re-compile the source code
' in it's current state. If you want to do that,
' please change the name of the project, and give the DLL
' an other filename then used. Actuallty, I would prefer
' you e-mail me the changes, so I release a new version of the DLL.
'
' Otherwise, some projects using the original DLL
' fail to run or crash at startup.
'
'==================================================================



'------------------------------------------------------------------------
' Constants

Public Const OBJPTR_BASE = 10000 ' Pointers below this value won't be accepted.
Public Const IDGEN_RANGE = &H1000&
Public Const IDGEN_MAX = &H7FFF& ' Max Int

Public Const BUTTON_IDGEN_BASE = &H6000&
Public Const BUTTON_IDGEN_MAX = BUTTON_IDGEN_BASE + IDGEN_RANGE - 1
Public Const MENU_IDGEN_BASE = BUTTON_IDGEN_BASE + IDGEN_RANGE
Public Const MENU_IDGEN_MAX = MENU_IDGEN_BASE + IDGEN_RANGE - 1

Public Const SRC_SUB = "()"
Public Const SRC_FUNCTION = "()"
Public Const SRC_PROP_GET = " [GET]"
Public Const SRC_PROP_LET = " [LET]"
Public Const SRC_PROP_SET = " [SET]"
Public Const SRC_MOD_UTILS = "MenuDeclarations"
Public Const SRC_MOD_DRAWING = "MenuOwnerDrawing"
Public Const SRC_CLASS_MENU = "MenuContainer."
Public Const SRC_CLASS_MENU_DRAW = "MenuContainer.DrawExtras."
Public Const SRC_CLASS_MENUITEM = "MenuItem."
Public Const SRC_CLASS_MENUITEM_DRAW = "MenuItem.DrawExtras."
Public Const SRC_CLASS_MENUITEMS = "MenuItems."

Public Const ERR_ARGUMENT = "Invalid Argument: "
Public Const ERR_CALL = "Invalid Procedure Call: "
Public Const ERR_VALUE = "Invalid Property Value: "
Public Const ERR_READ = "Read-Only Property: "
Public Const ERR_INTERNAL = "Internal Error at "

Public Const ERR_FAIL_DLLCALL = "Internal DLL Calling Error: "
Public Const ERR_FAIL_GET = ERR_FAIL_DLLCALL & "Failed to get menu info!"
Public Const ERR_FAIL_SET = ERR_FAIL_DLLCALL & "Failed to set menu info!"
Public Const ERR_FAIL_GETITEM = ERR_FAIL_DLLCALL & "Failed to get menu item info!"
Public Const ERR_FAIL_SETITEM = ERR_FAIL_DLLCALL & "Failed to set menu item info!"

Public Const ERR_FAIL_ADDITEM = ERR_FAIL_DLLCALL & "Failed to add menu item!"
Public Const ERR_FAIL_REMOVEITEM = ERR_FAIL_DLLCALL & "Failed to remove menu item!"

Public Const ERR_ITEM_SEP = ERR_CALL & "Menu item is an separator!"
Public Const ERR_ITEM_NOTBMP = ERR_CALL & "Menu item is property not a bitmap-style type!"
Public Const ERR_ITEM_SHORTCUT = ERR_VALUE & "ShortCut modifier/key combination is not valid!"
Public Const ERR_SUBMENU_EMPTY = ERR_VALUE & "Submenu doesn't contain any menu items!"

Public Const ERR_TYPE = ERR_VALUE & "Object does not implement "
Public Const ERR_SETIMAGE_NULL = ERR_VALUE & "IPicture type property can't be set to Nothing." & vbCrLf & "Use Set .Background = LoadPicture() instead."
Public Const ERR_SETIMAGE_TYPE = ERR_TYPE & "IPicture!"

Public Const ERR_SETFONT_NULL = ERR_VALUE & "GDIFont type property can't be set to Nothing." & vbCrLf & "Use .Restore* instead!"



'------------------------------------------------------------------------
' Declarations

Public MenuGlobal As GMenuFunctions

Public Declare Function GetSystemMetrics Lib "user32" (ByVal nIndex As GetSystemMetricsFlags) As Long
Public Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (DestPtr As Any, SourcePtr As Any, ByVal NumOfBytes As Long)
Public Declare Function OleCreatePictureIndirect Lib "olepro32.dll" (lpPictDesc As PictDesc, riid As GUID, ByVal fPictureOwnsHandle As Long, ipic As IPicture) As Long

Public Enum GetSystemMetricsFlags
  SM_CYMENU = 15
  SM_CYMENUCHECK = 72
End Enum


Public Type GUID
  Data1 As Long
  Data2 As Integer
  Data3 As Integer
  Data4(0 To 7) As Byte
End Type

Public Type PictDesc
  cbSizeofStruct As Long
  picType As Long
  hImage As Long
  xExt As Long
  yExt As Long
End Type


'------------------------------------------------------------------------
' Menu Containers

Public Declare Function CreateMenu Lib "user32" () As Long
Public Declare Function CreatePopupMenu Lib "user32" () As Long

Public Declare Function LoadMenuByLong Lib "user32" Alias "LoadMenuA" (ByVal hInstance As Long, ByVal ResID As Long) As Long
Public Declare Function LoadMenuByString Lib "user32" Alias "LoadMenuA" (ByVal hInstance As Long, ByVal lpResID As String) As Long
Public Declare Function LoadMenuByTemplate Lib "user32" Alias "LoadMenuIndirectA" (ByVal lpMenuTemplate As Long) As Long

Public Declare Function DestroyMenu Lib "user32" (ByVal hMenu As Long) As Long

Public Declare Function GetMenu Lib "user32" (ByVal hWnd As Long) As Long
Public Declare Function GetSystemMenuAPI Lib "user32" Alias "GetSystemMenu" (ByVal hWnd As Long, ByVal bRevert As Long) As Long
Public Declare Function SetMenu Lib "user32" (ByVal hWnd As Long, ByVal hMenu As Long) As Long
Public Declare Function GetParent Lib "user32" (ByVal hWnd As Long) As Long
Public Declare Function IsWindow Lib "user32" (ByVal hWnd As Long) As Long
Public Declare Function IsMenu Lib "user32" (ByVal hMenu As Long) As Long

Public Declare Function GetMenuInfo Lib "user32" (ByVal hMenu As Long, lpcmi As MENUINFO) As Long
Public Declare Function SetMenuInfo Lib "user32" (ByVal hMenu As Long, lpcmi As MENUINFO) As Long

Public Declare Function CheckMenuRadioItem Lib "user32" (ByVal hMenu As Long, ByVal un1 As Long, ByVal un2 As Long, ByVal un3 As Long, ByVal un4 As Long) As Long
Public Declare Function GetMenuDefaultItem Lib "user32" (ByVal hMenu As Long, ByVal fByPos As Long, ByVal gmdiFlags As Long) As Long
Public Declare Function SetMenuDefaultItem Lib "user32" (ByVal hMenu As Long, ByVal uItem As Long, ByVal fByPos As Long) As Long

Public Declare Function DrawMenuBar Lib "user32" (ByVal hWnd As Long) As Long
Public Declare Function EndMenu Lib "user32" () As Long

Public Declare Function GetMenuCheckMarkDimensions Lib "user32" () As DWORD

Public Declare Function TrackPopupMenu Lib "user32" (ByVal hMenu As Long, ByVal wFlags As Long, ByVal X As Long, ByVal Y As Long, ByVal nReserved As Long, ByVal hWnd As Long, lprc As Any) As Long ' 'lprc As RECT" changed into "lprc As Any"
Public Declare Function TrackPopupMenuEx Lib "user32" (ByVal hMenu As Long, ByVal un As Long, ByVal n1 As Long, ByVal n2 As Long, ByVal hWnd As Long, lpTPMParams As TPMPARAMS) As Long

Public Type POINTAPI
  X As Long
  Y As Long
End Type

Public Type DWORD
  LoWord As Integer
  HiWord As Integer
End Type

Public Type MENUINFO
  cbSize As Long
  fMask As Long
  dwStyle As Long
  cyMax As Long
  hBrBack As Long
  dwContextHelpID As Long
  dwMenuData As Long
End Type

Public Enum MenuInfoMasks
  MIM_MAXHEIGHT = &H1
  MIM_BACKGROUND = &H2
  MIM_HELPID = &H4
  MIM_MENUDATA = &H8
  MIM_STYLE = &H10
  MIM_APPLYTOSUBMENUS = &H80000000
End Enum

Public Type TPMPARAMS
  cbSize As Long
  rcExclude As RECT
End Type

Public Type MENUITEMTEMPLATE
  mtOption As Integer
  mtID As Integer
  mtString As Byte
End Type

Public Type MENUITEMTEMPLATEHEADER
  versionNumber As Integer
  offset As Integer
End Type

Public Type MENUEX_TEMPLATE_HEADER
  wVersion As Integer
  wOffset As Integer
  dwHelpId As Long
End Type

Public Type MENUEX_TEMPLATE_ITEM
  dwType As Long
  dwState As Long
  uId As Long
  bResInfo As Integer
  szText As String
  dwHelpId As Long
End Type

'------------------------------------------------------------------------
' Menu Items

Public Declare Function InsertMenuItem Lib "user32" Alias "InsertMenuItemA" (ByVal hMenu As Long, ByVal uItem As Long, ByVal fByPosition As Boolean, lpcMenuItemInfo As MENUITEMINFO) As Long
Public Declare Function GetMenuItemInfo Lib "user32" Alias "GetMenuItemInfoA" (ByVal hMenu As Long, ByVal uItem As Long, ByVal fByPosition As Boolean, lpMenuItemInfo As MENUITEMINFO) As Long
Public Declare Function SetMenuItemInfo Lib "user32" Alias "SetMenuItemInfoA" (ByVal hMenu As Long, ByVal uItem As Long, ByVal fByPosition As Boolean, lpcMenuItemInfo As MENUITEMINFO) As Long
Public Declare Function RemoveMenu Lib "user32" (ByVal hMenu As Long, ByVal nPosition As Long, ByVal wFlags As Long) As Long
Public Declare Function DeleteMenu Lib "user32" (ByVal hMenu As Long, ByVal nPosition As Long, ByVal wFlags As Long) As Long
Public Declare Function GetMenuItemCount Lib "user32" (ByVal hMenu As Long) As Long

Public Declare Function GetMenuItemID Lib "user32" (ByVal hMenu As Long, ByVal nPos As Long) As Long
Public Declare Function GetMenuItemRect Lib "user32" (ByVal hWnd As Long, ByVal hMenu As Long, ByVal uItem As Long, lprcItem As RECT) As Long
Public Declare Function GetMenuString Lib "user32" Alias "GetMenuStringA" (ByVal hMenu As Long, ByVal wIDItem As Long, ByVal lpString As String, ByVal nMaxCount As Long, ByVal wFlag As Long) As Long
Public Declare Function GetSubMenu Lib "user32" (ByVal hMenu As Long, ByVal nPos As Long) As Long

Public Const MF_BYCOMMAND = &H0
Public Const MF_BYPOSITION = &H400

Public Type MENUITEMINFO
  cbSize As Long
  fMask As Long
  fType As Long
  fState As Long
  wID As Long
  hSubMenu As Long
  hbmpChecked As Long
  hbmpUnchecked As Long
  dwItemData As Long
  dwTypeData As Long
  cch As Long
  hBmpItem As Long ' W98
End Type

Public Enum MenuItemInfoMasks
  MIIM_STATE = &H1
  MIIM_ID = &H2
  MIIM_SUBMENU = &H4
  MIIM_CHECKMARKS = &H8
  MIIM_TYPE = &H10
  MIIM_DATA = &H20
  MIIM_STRING = &H40
  MIIM_BITMAP = &H80
  MIIM_FTYPE = &H100
End Enum

'------------------------------------------------------------------------
' Menu Owner Drawing - Font Support

Public Const LF_FACESIZE = 32
Public Const LF_FULLFACESIZE = 64

Public Type LOGFONT
  lfHeight As Long
  lfWidth As Long
  lfEscapement As Long
  lfOrientation As Long
  lfWeight As Long
  lfItalic As Byte
  lfUnderline As Byte
  lfStrikeOut As Byte
  lfCharSet As Byte
  lfOutPrecision As Byte
  lfClipPrecision As Byte
  lfQuality As Byte
  lfPitchAndFamily As Byte
  lfFaceName(LF_FACESIZE) As Byte
End Type

Public Declare Function CreateFontIndirectNM Lib "gdi32" Alias "CreateFontIndirectA" (lpLogFont As NMLOGFONT) As Long
Public Declare Function GetObject Lib "gdi32" Alias "GetObjectA" (ByVal hObject As Long, ByVal nCount As Long, lpObject As Any) As Long
Public Declare Function SystemParametersInfo Lib "user32" Alias "SystemParametersInfoA" (ByVal uAction As SystemParamsMenuCommands, ByVal uParam As Long, lpvParam As Any, ByVal fuWinIni As Long) As Long

Public Enum SystemParamsMenuCommands
  SPI_GETNONCLIENTMETRICS = 41
  SPI_GETMENUDROPALIGNMENT = 27
  SPI_SETMENUDROPALIGNMENT = 28
  SPI_GETMENUANIMATION = &H1002
  SPI_SETMENUANIMATION = &H1003
  SPI_GETMENUUNDERLINES = &H100A
  SPI_SETMENUUNDERLINES = &H100B
  SPI_GETHOTTRACKING = &H100E
  SPI_SETHOTTRACKING = &H100F
End Enum

' Here but thanks to a bit of hacking (testing cbSize
' parameter until it worked - see XXXTest1!) is the required
' definition for NONCLIENTMETRICS structure - differs
' to the one in WIN32API.TXT with VB.
' For some bizarre reason, maybe to do with byte
' alignment, the LOGFONT structure we must apply
' to NONCLIENTMETRICS seems to require an LF_FACESIZE
' 4 bytes smaller than normal:
Private Const METRICS_USEDEFAULT = -1
Private Type NMLOGFONT
  lfHeight As Long
  lfWidth As Long
  lfEscapement As Long
  lfOrientation As Long
  lfWeight As Long
  lfItalic As Byte
  lfUnderline As Byte
  lfStrikeOut As Byte
  lfCharSet As Byte
  lfOutPrecision As Byte
  lfClipPrecision As Byte
  lfQuality As Byte
  lfPitchAndFamily As Byte
  lfFaceName(LF_FACESIZE - 4) As Byte
End Type

Public Type NONCLIENTMETRICS
  cbSize As Long
  iBorderWidth As Long
  iScrollWidth As Long
  iScrollHeight As Long
  iCaptionWidth As Long
  iCaptionHeight As Long
  lfCaptionFont As NMLOGFONT
  iSMCaptionWidth As Long
  iSMCaptionHeight As Long
  lfSMCaptionFont As NMLOGFONT
  iMenuWidth As Long
  iMenuHeight As Long
  lfMenuFont As NMLOGFONT
  lfStatusFont As NMLOGFONT
  lfMessageFont As NMLOGFONT
End Type


'------------------------------------------------------------------------
' Main: Load dilter bitmap for menu owner drawing

Public Sub Main()
  Set bmpDilter = LoadResPicture(DILTER_BITMAP_RESID, vbResBitmap)
  Set CurDefaultFont = New GDIFont
  Set CurDefaultFontBold = New GDIFont
  Set MenuGlobal = New GMenuFunctions
  Debug.Assert bmpDilter.Handle
End Sub


'------------------------------------------------------------------------
' Get Unique ID:

Public Function Menu_GetUniqueID(ByVal hMenu As OLE_HANDLE) As Integer
  Static ID As Long
  Dim MENUITEMINFO As MENUITEMINFO
  
  If ID = 0 Then ID = MENU_IDGEN_BASE
  MENUITEMINFO.cbSize = LenB(MENUITEMINFO)
  MENUITEMINFO.fMask = MIIM_ID
  Do
    ID = ID + 1
    If ID > MENU_IDGEN_MAX Then Error 6
  Loop While GetMenuItemInfo(hMenu, ID, False, MENUITEMINFO) <> 0
  Menu_GetUniqueID = CInt(ID)
End Function

'------------------------------------------------------------------------
' Menu shortcut tools

Public Function Menu_ShortCutValid(ByVal ShortCutModifier As ShiftConstants, ByVal ShortCutCode As KeyCodeConstants) As Boolean
  Menu_ShortCutValid = False
  If vbKeyA <= ShortCutCode And ShortCutCode <= vbKeyZ Then
    If ShortCutModifier = 0 Then Exit Function
  End If
  If vbKey0 <= ShortCutCode And ShortCutCode <= vbKey9 Then
    If ShortCutModifier = 0 Then Exit Function
  End If
  If ShortCutCode < vbKeyBack Then Exit Function     ' Not useful characters
  If ShortCutCode <= vbKeyMenu And _
     ShortCutCode > vbKeyTab And _
     ShortCutCode <> vbKeyReturn Then Exit Function  ' Not useful characters
  If vbKeyCapital <= ShortCutCode And _
     ShortCutCode < vbKeyEscape Then Exit Function   ' Not useful characters
  If vbKeySelect <= ShortCutCode And _
    ShortCutCode <= vbKeySnapshot Then Exit Function ' Not useful characters
  If ShortCutCode = vbKeyHelp Then Exit Function     ' Numbers follow after this code
  If vbKey9 < ShortCutCode And _
     ShortCutCode < vbKeyA Then Exit Function        ' Range between 9 and A
  If vbKeyZ < ShortCutCode And _
     ShortCutCode < vbKeyNumpad0 Then Exit Function  ' Range between Z and Numpad 0
  If vbKeyNumpad9 < ShortCutCode And _
     ShortCutCode < vbKeyF1 Then Exit Function       ' Range between Numpad 9 and F1
  If ShortCutCode > vbKeyF16 Then Exit Function      ' All other high values
  If ShortCutModifier <> 0 And _
     ShortCutCode = 0 Then Exit Function             ' Modifier needs code
  Menu_ShortCutValid = True
End Function

'------------------------------------------------------------------------
' COM/OLE object retreival

Public Function GetObjFromPtr(ByVal ObjPtr As Long) As Object
  Dim Obj As Object
  Dim ObjGet As Object
  If ObjPtr >= OBJPTR_BASE Then
    On Error Resume Next
      Call CopyMemory(ObjGet, ObjPtr, 4) ' Turn the pointer into an ILLEGAL, UNCOUNTED interface
      Set Obj = ObjGet                   ' Assign to legal reference (Object references will be counted and registered by VB)
      Call CopyMemory(ObjGet, 0&, 4)     ' Destroy the illegal reference (Can't harm VB anymore)
    On Error GoTo 0
    Set GetObjFromPtr = Obj              ' Return legal object reference
  End If
End Function


'------------------------------------------------------------------------
' COM/OLE IPicture/Color support

Public Function GetPictureObj(ByVal hBmp As OLE_HANDLE) As IPicture
  Dim OlePic As Picture
  Dim ConversionData As PictDesc
  Dim OlePicGUID As GUID
  
  ' Fill PictDesc structure with necessary parts:
  With ConversionData
    .cbSizeofStruct = Len(ConversionData)
    .picType = vbPicTypeBitmap
    .hImage = hBmp
  End With
  
  ' Fill in IDispatch Interface ID
  With OlePicGUID
    .Data1 = &H20400
    .Data4(0) = &HC0
    .Data4(7) = &H46
  End With
  
  If OleCreatePictureIndirect(ConversionData, OlePicGUID, False, OlePic) <> 0 Then Call RaiseVBDLLError("<MenuDeclarations.GetPictureObj()>", "Failed to convert menu icon to OLE picture object!")
  Set GetPictureObj = OlePic
End Function


'------------------------------------------------------------------------
' MenuInfo wrapper


Public Function Menu_GetInfo(ByVal hMenu As OLE_HANDLE, ByVal Mask As MenuInfoMasks) As MENUINFO
  Const ERR_SRC = SRC_MOD_UTILS & "Menu_GetInfo" & SRC_FUNCTION
  Menu_GetInfo.cbSize = LenB(Menu_GetInfo)
  Menu_GetInfo.fMask = Mask
  If GetMenuInfo(hMenu, Menu_GetInfo) = 0 Then Call RaiseVBDLLError(ERR_SRC, ERR_FAIL_GET)
End Function

Public Function Menu_GetItemInfo(ByVal hMenu As OLE_HANDLE, ByVal ID As Long, ByVal Mask As MenuItemInfoMasks) As MENUITEMINFO
  Const ERR_SRC = SRC_MOD_UTILS & "Menu_GetItemInfo" & SRC_FUNCTION
  Menu_GetItemInfo.cbSize = LenB(Menu_GetItemInfo)
  Menu_GetItemInfo.fMask = Mask
  If GetMenuItemInfo(hMenu, ID, False, Menu_GetItemInfo) = 0 Then Call RaiseVBDLLError(ERR_SRC, ERR_FAIL_GETITEM)
End Function
