VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "MenuItems"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Description = "Contains the menu items added to a menubar/submenu/popup menu"
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"No"
Attribute VB_Ext_KEY = "Collection" ,"UserDefinedCollection"
Attribute VB_Ext_KEY = "Member0" ,"MenuItem"
Option Explicit

'==================================================================
'
' Menu Item Collection Class for MenuContainer
'
' 1 October 2001
'
' You're free in using this software, as long as the
' orignal copyright/author information remains intact.
' In other words, respecting the person(s) who made it
' possible for you to view/learn something of this software.
'
' Copyright  2001 - Diederik van der Boor
' http://www.codingdomain.com
'
' Important Note: *NEVER* re-compile the source code
' in it's current state. If you want to do that,
' please change the name of the project, and give the DLL
' an other filename then used. Actuallty, I would prefer
' you e-mail me the changes, so I release a new version of the DLL.
'
' Otherwise, some projects using the original DLL
' fail to run or crash at startup.
'
'==================================================================



'------------------------------------------------------------------------
' Declarations

Private CurhMenu As OLE_HANDLE
Private CurItems As Collection

'------------------------------------------------------------------------
' Attach to a menu container

Friend Sub Class_InitProps(ByVal hMenu As OLE_HANDLE)
  CurhMenu = hMenu
  Set CurItems = New Collection
End Sub

'------------------------------------------------------------------------
' Add a menu item

Public Function Add(Optional ByVal ID As Integer, Optional ByVal Caption As String, Optional ByVal ShortCutModifier As ShiftConstants, Optional ByVal ShortCutCode As KeyCodeConstants, Optional ByVal MenuType As MenuTypeFlags, Optional ByVal MenuState As MenuStateFlags, Optional ByVal Bitmap As IPicture, Optional ByVal CheckedBitmap As IPicture, Optional ByVal StandardBitmap As MenuStandardBitmaps, Optional ByVal SubMenu As MenuContainer, Optional ByVal InsertBefore As MenuItem) As MenuItem
Attribute Add.VB_Description = "Adds a menu item to the menu."
  Const ERR_SRC = SRC_CLASS_MENUITEMS & "Add" & SRC_FUNCTION
  Dim Item As MenuItem
  Dim ItemInfo As MENUITEMINFO
  
  If (MenuType And mnuFlagSeparator) = mnuFlagSeparator Then
    If Caption <> "" Then Err.Raise 5, ERR_SRC, ERR_ITEM_SEP
    If ShortCutModifier <> 0 Then Err.Raise 5, ERR_SRC, ERR_ITEM_SEP
    If ShortCutCode <> 0 Then Err.Raise 5, ERR_SRC, ERR_ITEM_SEP
    If Not SubMenu Is Nothing Then Err.Raise 5, ERR_SRC, ERR_ITEM_SEP
    Caption = vbNullString
  End If

  If ShortCutCode <> 0 Then
    If Not Menu_ShortCutValid(ShortCutModifier, ShortCutCode) Then Err.Raise 380, ERR_SRC, ERR_ITEM_SHORTCUT
  Else
    If ShortCutModifier <> 0 Then Err.Raise 5, ERR_SRC, ERR_ARGUMENT & "Shortcut modifier needs shortcut key code!"
  End If

  If Bitmap Is Nothing Then Set Bitmap = LoadPicture()
  If CheckedBitmap Is Nothing Then Set CheckedBitmap = Bitmap
  If Not (TypeOf Bitmap Is StdPicture Or TypeOf Bitmap Is IPicture Or TypeOf Bitmap Is IPictureDisp) Then Err.Raise 5, ERR_SRC, ERR_SETIMAGE_TYPE
  If Not (TypeOf CheckedBitmap Is StdPicture Or TypeOf CheckedBitmap Is IPicture Or TypeOf CheckedBitmap Is IPictureDisp) Then Err.Raise 5, ERR_SRC, ERR_SETIMAGE_TYPE
  If ID >= MENU_IDGEN_BASE Or ID < 0 Then Err.Raise 5, ERR_SRC, ERR_CALL & "ID out of valid range!"
  
  If ID = 0 Then ID = Menu_GetUniqueID(CurhMenu)
  
  Set Item = New MenuItem
  Caption = StrConv(Caption, vbFromUnicode)
  ItemInfo.cbSize = LenB(ItemInfo)
  ItemInfo.fMask = MIIM_ID Or MIIM_STATE Or MIIM_FTYPE Or MIIM_STRING Or MIIM_BITMAP Or MIIM_DATA
  ' ItemInfo.fMask = ItemInfo.fMask or MIIM_TYPE
  ItemInfo.wID = CLng(ID)               ' MIIM_ID
  ItemInfo.dwTypeData = StrPtr(Caption) ' MIIM_TYPE
  ItemInfo.dwItemData = -ObjPtr(Item)   ' MIIM_DATA
  ItemInfo.cch = LenB(Caption)          ' MIIM_TYPE
  ItemInfo.fType = MenuType             ' MIIM_FTYPE
  ItemInfo.fState = MenuState           ' MIIM_STATE
  ItemInfo.hBmpItem = StandardBitmap    ' MIIM_BITMAP
  If Not SubMenu Is Nothing Then
    If Not TypeOf SubMenu Is MenuContainer Then Err.Raise 5, ERR_SRC, ERR_TYPE & "MenuContainer!"
    If GetMenuItemCount(SubMenu.hMenu) = 0 Then Err.Raise 380, ERR_SRC, ERR_SUBMENU_EMPTY
    ItemInfo.fMask = ItemInfo.fMask Or MIIM_SUBMENU
    ItemInfo.hSubMenu = SubMenu.hMenu
  End If
  If Bitmap.Handle <> 0 Or CheckedBitmap.Handle <> 0 Then
    ItemInfo.fMask = ItemInfo.fMask Or MIIM_CHECKMARKS
    ItemInfo.hbmpUnchecked = Bitmap.Handle      ' MIIM_CHECKMARKS
    ItemInfo.hbmpChecked = CheckedBitmap.Handle ' MIIM_CHECKMARKS
  End If
  If Not InsertBefore Is Nothing Then
    If Not TypeOf InsertBefore Is MenuItem Then Err.Raise 5, ERR_SRC, ERR_TYPE & "MenuContainer!"
    If InsertMenuItem(CurhMenu, InsertBefore.ID, False, ItemInfo) = 0 Then Call RaiseVBDLLError(ERR_SRC, ERR_FAIL_ADDITEM)
  Else
    If InsertMenuItem(CurhMenu, Me.Count, True, ItemInfo) = 0 Then Call RaiseVBDLLError(ERR_SRC, ERR_FAIL_ADDITEM)
  End If
  
  Call Item.Class_InitProps(CurhMenu, ID, ShortCutModifier, ShortCutCode, Bitmap, CheckedBitmap, SubMenu)
  Call CurItems.Add(Item, "OBJPTR_" & -ItemInfo.dwItemData)
  
  Set Add = Item
End Function

'------------------------------------------------------------------------
' Retreive a menu item

Public Property Get Item(ByVal Index As Long, Optional ByVal IndexType As MenuItemIndexType = mnuItemByPosition) As MenuItem
Attribute Item.VB_Description = "Retreives a single menu item in the menu."
Attribute Item.VB_UserMemId = 0
Attribute Item.VB_MemberFlags = "200"
  Const ERR_SRC = SRC_CLASS_MENUITEMS & "Item" & SRC_PROP_GET
  Dim Info As MENUITEMINFO
  Info.cbSize = LenB(Info)
  Info.fMask = MIIM_DATA
  If IndexType = mnuItemByPosition Then Index = Index - 1
  If GetMenuItemInfo(CurhMenu, Index, (IndexType = mnuItemByPosition), Info) = 0 Then Call RaiseVBDLLError(ERR_SRC, ERR_FAIL_GETITEM)
  On Error Resume Next
    Set Item = CurItems("OBJPTR_" & -Info.dwItemData) ' Do we have the reference here local?
  On Error GoTo 0
  If Item Is Nothing Then
'   NO, build a new MenuItem object
'   It could also be possible that we're dealing wich an other MenuItems class/object instance!
'   Set Item = GetObjFromPtr(-Info.dwItemData) ' If it's an other object instance, we could retreive that object or CRASH if it's not!!
    Set Item = New MenuItem
    Info.fMask = MIIM_ID Or MIIM_CHECKMARKS Or MIIM_DATA
    If GetMenuItemInfo(CurhMenu, Index, (IndexType = mnuItemByPosition), Info) = 0 Then Call RaiseVBDLLError(ERR_SRC, ERR_FAIL_GETITEM)
    Call Item.Class_InitProps(CurhMenu, Info.wID, 0, 0, GetPictureObj(Info.hbmpUnchecked), GetPictureObj(Info.hbmpChecked), Nothing)
'    If Info.dwItemData = 0 Then ' SubObject needs to be saved too!
'     Label menu item so we won't have to make an object for this item again.
      Info.fMask = MIIM_DATA
      Info.dwItemData = -ObjPtr(Item)
      If SetMenuItemInfo(CurhMenu, Index, (IndexType = mnuItemByPosition), Info) = 0 Then Call RaiseVBDLLError(ERR_SRC, ERR_FAIL_SETITEM)
      Call CurItems.Add(Item, "OBJPTR_" & -Info.dwItemData)
'    End If
' Else
'   Set Item = GetObjFromPtr(-Info.dwItemData) ' Retreive object from pointer.
  End If
End Property

'------------------------------------------------------------------------
' Get the number of added menu items

Public Property Get Count() As Long
Attribute Count.VB_Description = "Returns the number of menu items."
  Const ERR_SRC = SRC_CLASS_MENUITEMS & "Count" & SRC_PROP_GET
  Count = GetMenuItemCount(CurhMenu)
  If Count = -1 Then Call RaiseVBDLLError(ERR_SRC, ERR_FAIL_DLLCALL & "Coun't count menu items!")
End Property

'------------------------------------------------------------------------
' Delete a menu item

Public Sub Remove(ByVal Index As Long, Optional ByVal IndexType As MenuItemIndexType = mnuItemByID, Optional ByVal DestroySubMenus As Boolean = True)
Attribute Remove.VB_Description = "Remove a menu item."
  Const ERR_SRC = SRC_CLASS_MENUITEMS & "Remove" & SRC_SUB
  Dim Info As MENUITEMINFO
  Info.cbSize = LenB(Info)
  Info.fMask = MIIM_DATA
  If IndexType = mnuItemByPosition Then Index = Index - 1
  If GetMenuItemInfo(CurhMenu, Index, (IndexType = mnuItemByPosition), Info) = 0 Then Call RaiseVBDLLError(ERR_SRC, ERR_FAIL_GETITEM)
  If DestroySubMenus Then
    If DeleteMenu(CurhMenu, Index, IndexType) = 0 Then Call RaiseVBDLLError(ERR_SRC, ERR_FAIL_REMOVEITEM)
  Else
    If RemoveMenu(CurhMenu, Index, IndexType) = 0 Then Call RaiseVBDLLError(ERR_SRC, ERR_FAIL_REMOVEITEM)
  End If
  Call CurItems.Remove("OBJPTR_" & -Info.dwItemData)
End Sub
