Attribute VB_Name = "MenuOwnerDrawing"
Option Explicit

'==================================================================
'
' Menu Owner Drawing Routines
'
' 1 October 2001
'
' You're free in using this software, as long as the
' orignal copyright/author information remains intact.
' In other words, respecting the person(s) who made it
' possible for you to view/learn something of this software.
'
' Copyright  2001 - Diederik van der Boor
' http://www.codingdomain.com
'
' Important Note: *NEVER* re-compile the source code
' in it's current state. If you want to do that,
' please change the name of the project, and give the DLL
' an other filename then used. Actuallty, I would prefer
' you e-mail me the changes, so I release a new version of the DLL.
'
' Otherwise, some projects using the original DLL
' fail to run or crash at startup.
'
'==================================================================




'------------------------------------------------------------------------
' Some settings you won't use so often. (I don't know if they work all ok)

Public Const ICON_BORDER_LEFT = 1       ' Icon border: left size
Public Const ICON_BORDER_TOP = 1        ' Icon border: top size
Public Const ICON_BORDER_RIGHT = 2      ' Icon border: right size
Public Const ICON_BORDER_BOTTOM = 2     ' Icon border: bottom size
Public Const ICON_RADIO_SIZE = 6        ' Radio checkmark size
Public Const MENU_SEP_PADDING = 2       ' Menu separator padding

Public Const ERR_FAIL_MOVETO = ERR_FAIL_DLLCALL & "Failed to move pen!"
Public Const ERR_FAIL_LINETO = ERR_FAIL_DLLCALL & ERR_FAIL_DLLCALL & "Failed to draw a line!"


'------------------------------------------------------------------------
' Owner Drawn Menus: Storage for default font objects

Public CurDefaultFont As GDIObjects.GDIFont
Public CurDefaultFontBold As GDIObjects.GDIFont
Public Const DILTER_BITMAP_RESID = 200
Public bmpDilter As IPictureDisp


'------------------------------------------------------------------------
' GDI Declarations

Public Declare Function GetTextExtentPoint32 Lib "gdi32" Alias "GetTextExtentPoint32A" (ByVal hDC As Long, ByVal lpsz As String, ByVal cbString As Long, lpSize As SIZE) As Long
Public Declare Function SetBkColor Lib "gdi32" (ByVal hDC As Long, ByVal crColor As Long) As Long
Public Declare Function SetBkMode Lib "gdi32" (ByVal hDC As Long, ByVal nBkMode As DCBackgroundMode) As DCBackgroundMode
Public Declare Function DrawEdge Lib "user32" (ByVal hDC As Long, qrc As RECT, ByVal edge As DCEdgeTypeFlags, ByVal grfFlags As DCBorderTypeFlags) As Long
Public Declare Function DrawTextEx Lib "user32" Alias "DrawTextExA" (ByVal hDC As Long, ByVal lpsz As String, ByVal N As Long, lpRect As RECT, ByVal un As DCDrawTextFlags, lpDrawTextParams As Any) As Long
Public Declare Function DrawState Lib "user32" Alias "DrawStateA" (ByVal hDC As Long, ByVal hBrush As Long, ByVal lpDrawStateProc As Long, ByVal hBmp As Long, ByVal wData As Long, ByVal X As Long, ByVal Y As Long, ByVal CX As Long, ByVal CY As Long, ByVal fuFlags As DCStateFlags) As Long
Public Declare Function DrawStateString Lib "user32" Alias "DrawStateA" (ByVal hDC As Long, ByVal hBrush As Long, ByVal lpDrawStateProc As Long, ByVal lpString As String, ByVal cbStringLen As Long, ByVal X As Long, ByVal Y As Long, ByVal CX As Long, ByVal CY As Long, ByVal fuFlags As DCStateFlags) As Long
Public Declare Function FillRect Lib "user32" (ByVal hDC As Long, lpRect As RECT, ByVal hBrush As Long) As Long
Public Declare Function SetTextColor Lib "gdi32" (ByVal hDC As Long, ByVal crColor As Long) As Long

Public Declare Function BitBlt Lib "gdi32" (ByVal hDCDest As Long, ByVal XDest As Long, ByVal YDest As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hDCSrc As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal dwRop As DCRasterOperations) As Long
Public Declare Function Arc Lib "gdi32" (ByVal hDC As Long, ByVal X1 As Long, ByVal Y1 As Long, ByVal X2 As Long, ByVal Y2 As Long, ByVal X3 As Long, ByVal Y3 As Long, ByVal X4 As Long, ByVal Y4 As Long) As Long
Public Declare Function Ellipse Lib "gdi32" (ByVal hDC As Long, ByVal X1 As Long, ByVal Y1 As Long, ByVal X2 As Long, ByVal Y2 As Long) As Long
Public Declare Function LineTo Lib "gdi32" (ByVal hDC As Long, ByVal X As Long, ByVal Y As Long) As Long
Public Declare Function MoveToEx Lib "gdi32" (ByVal hDC As Long, ByVal X As Long, ByVal Y As Long, lpPoint As Any) As Long
Public Declare Function SetPixel Lib "gdi32" (ByVal hDC As Long, ByVal X As Long, ByVal Y As Long, ByVal crColor As Long) As Long

Public Declare Function GetCurrentObject Lib "gdi32" (ByVal hDC As Long, ByVal uObjectType As GDIObjects.GDIObjectTypes) As Long

Public Const CLR_INVALID = -1

Public Enum DCBackgroundMode
  dcBgModeTransparent = 1 ' BGMODE_TRANSPARENT
  dcBgModeOpaque = 2      ' BGMODE_OPAQUE
End Enum

Public Enum DCEdgeTypeFlags
  dcBorderRaisedOuther = &H1                                      ' BDR_RAISEDOUTER
  dcBorderSunkenOuther = &H2                                      ' BDR_SUNKENOUTER
  dcBorderRaisedInner = &H4                                       ' BDR_RAISEDINNER
  dcBorderSunkenInner = &H8                                       ' BDR_SUNKENINNER
  dcBorderRaised = (dcBorderRaisedOuther Or dcBorderRaisedInner)  ' EDGE_RAISED
  dcBorderSunken = (dcBorderSunkenOuther Or dcBorderSunkenInner)  ' EDGE_SUNKEN
  dcBorderEtched = (dcBorderSunkenOuther Or dcBorderRaisedInner)  ' EDGE_ETCHED
  dcBorderBump = (dcBorderRaisedOuther Or dcBorderSunkenInner)    ' EDGE_BUMP
End Enum

Public Enum DCBorderTypeFlags
  dcBorderLeft = &H1                                                                      ' BF_LEFT
  dcBorderTop = &H2                                                                       ' BF_TOP
  dcBorderRight = &H4                                                                     ' BF_RIGHT
  dcBorderBottom = &H8                                                                    ' BF_BOTTOM
  dcBorderTopLeft = (dcBorderTop Or dcBorderLeft)                                         ' BF_TOPLEFT
  dcBorderTopRight = (dcBorderTop Or dcBorderRight)                                       ' BF_TOPRIGHT
  dcBorderBottomLeft = (dcBorderBottom Or dcBorderLeft)                                   ' BF_BOTTOMLEFT
  dcBorderBottomRight = (dcBorderBottom Or dcBorderRight)                                 ' BF_BOTTOMRIGHT
  dcBorderRect = (dcBorderLeft Or dcBorderTop Or dcBorderRight Or dcBorderBottom)         ' BF_RECT
  dcBorderDiagonal = &H10                                                                 ' BF_DIAGONAL
  
' For diagonal lines, the BF_RECT flags specify the end point of the
' vector bounded by the rectangle parameter.
  dcBorderDiagonalEndTopLeft = (dcBorderDiagonal Or dcBorderTop Or dcBorderLeft)          ' BF_DIAGONAL_ENDTOPLEFT
  dcBorderDiagonalEndTopRight = (dcBorderDiagonal Or dcBorderTop Or dcBorderRight)        ' BF_DIAGONAL_ENDTOPRIGHT
  dcBorderDiagonalEndBottomLeft = (dcBorderDiagonal Or dcBorderBottom Or dcBorderLeft)    ' BF_DIAGONAL_ENDBOTTOMLEFT
  dcBorderDiagonalEndBottomRight = (dcBorderDiagonal Or dcBorderBottom Or dcBorderRight)  ' BF_DIAGONAL_ENDBOTTOMRIGHT
  
  dcBorderMiddle = &H800                                                                  ' BF_MIDDLE: Fill in the middle
  dcBorderSoft = &H1000                                                                   ' BF_SOFT:   For softer buttons
  dcBorderAdjust = &H2000                                                                 ' BF_ADJUST: Calculate the space left over
  dcBorderFlat = &H4000                                                                   ' BF_FLAT:   For flat rather than 3D borders
  dcBorderMono = &H8000                                                                   ' BF_MONO:   For monochrome borders
End Enum

Public Enum DCDrawTextFlags
  dcDrawAlignLeft = &H0         ' DT_LEFT
  dcDrawAlignCenter = &H1       ' DT_CENTER
  dcDrawAlignRight = &H2        ' DT_RIGHT
  dcDrawAlignTop = &H0          ' DT_TOP
  dcDrawAlignMiddle = &H4       ' DT_VCENTER
  dcDrawAlignBottom = &H8       ' DT_BOTTOM
  
  dcDrawWordBreak = &H10        ' DT_WORDBREAK
  dcDrawSingleLine = &H20       ' DT_SINGLELINE
  dcDrawExpandTabs = &H40       ' DT_EXPANDTABS
  dcDrawTabStop = &H80          ' DT_TABSTOP
  dcDrawNoClip = &H100          ' DT_NOCLIP
  dcDrawNoPrefix = &H800        ' DT_NOPREFIX
  dcDrawEndEllipsis = &H8000&   ' DT_END_ELLIPSIS
  
  dcDrawPlotter = 0             ' DT_PLOTTER
  dcDrawRasDisplay = 1          ' DT_RASDISPLAY
  dcDrawRasPrinter = 2          ' DT_RASPRINTER
  dcDrawRasCamera = 3           ' DT_RASCAMERA
  dcDrawCharStream = 4          ' DT_CHARSTREAM
  dcDrawMetaFile = 5            ' DT_METAFILE
  dcDrawDispayFile = 6          ' DT_DISPFILE
  dcDrawCalcRectInstead = &H400 ' DT_CALCRECT
  dcDrawExternalLeading = &H200 ' DT_EXTERNALLEADING
  dcDrawInternal = &H1000       ' DT_INTERNAL
End Enum

Public Enum DCStateFlags
  dcStateCallBack = &H0     ' DST_COMPLEX
  dcStateText = &H1         ' DST_TEXT
  dcStatePrefixText = &H2   ' DST_PREFIXTEXT
  dcStateIcon = &H3         ' DST_ICON
  dcStateBitmap = &H4       ' DST_BITMAP
  
  dcStateNormal = &H0       ' DSS_NORMAL
  dcStateUnion = &H10       ' DSS_UNION
  dcStateDisabled = &H20    ' DSS_DISABLED
  dcStateBrushColor = &H80  ' DSS_MONO
  dcStateRight = &H8000     ' DSS_RIGHT
End Enum

Public Enum DCRasterOperations
  dcBitBlackness = &H42         ' BLACKNESS
  dcBitDestInvert = &H550009    ' DSTINVERT
  dcBitMergeCopy = &HC000CA     ' MERGECOPY
  dcBitMergePaint = &HBB0226    ' MERGEPAINT
  dcBitNotSrcCopy = &H330008    ' NOTSRCCOPY
  dcBitNotSrcErase = &H1100A6   ' NOTSRCERASE
  dcBitPatCopy = &HF00021       ' PATCOPY
  dcBitPatInvert = &H5A0049     ' PATINVERT
  dcBitPatPaint = &HFB0A09      ' PATPAINT
  dcBitSrcAnd = &H8800C6        ' SRCAND
  dcBitSrcCopy = &HCC0020       ' SRCCOPY
  dcBitSrcErase = &H440328      ' SRCERASE
  dcBitSrcInvert = &H660046     ' SRCINVERT
  dcBitSrcPaint = &HEE0086      ' SRCPAINT
  dcBitWhiteness = &HFF0062     ' WHITENESS
  dcBitNoMirrorBmp = &H80000000 ' NOMIRRORBITMAP ' not in 95
End Enum




'------------------------------------------------------------------------
' Owner Drawn Menus: Find out how large we want to the menu to be.

Public Function Menu_MeasureItem(ByVal MenuItem As MenuItem) As SIZE
  Const ERR_SRC = SRC_MOD_DRAWING & "Menu_MeasureItem" & SRC_FUNCTION
  Dim MenuDC As GDIObjects.GDIDC
  Dim Caption As String
  Dim IconHeight As Long
  
  If (MenuItem.MenuType And mnuFlagSeparator) = mnuFlagSeparator Then
    ' Well, that's nice...
    Menu_MeasureItem.CX = 32
    Menu_MeasureItem.CY = 6
  Else
    ' Make and prepare DC for font testing
    Set MenuDC = GDIObjects.GDICreateDCC(, , True)
    If ((MenuItem.MenuState And mnuStateDefault) = mnuStateDefault) Then
      Set MenuDC.SelFont = MenuItem.DrawExtras.DefaultFont
    Else
      Set MenuDC.SelFont = MenuItem.DrawExtras.NormalFont
    End If
    
    ' Determine width/height
    Caption = MenuItem.Caption
    IconHeight = MenuItem.DrawExtras.Metrics(mnuMtrIconHeight)
    If GetTextExtentPoint32(MenuDC.hDC, Caption, Len(Caption), Menu_MeasureItem) = 0 Then Call RaiseVBDLLError(ERR_SRC, ERR_FAIL_DLLCALL & "Failed to get text metrics!")
    
    ' Adjust
    Menu_MeasureItem.CX = Menu_MeasureItem.CX + ICON_BORDER_LEFT + MenuItem.DrawExtras.Metrics(mnuMtrIconWidth) + ICON_BORDER_RIGHT + 4
    If InStr(1, Caption, vbTab) = 0 Then Menu_MeasureItem.CX = Menu_MeasureItem.CX + 20
    If Menu_MeasureItem.CY < (ICON_BORDER_TOP + IconHeight + ICON_BORDER_BOTTOM) Then Menu_MeasureItem.CY = (ICON_BORDER_TOP + IconHeight + ICON_BORDER_BOTTOM)
    
    ' Clearup
    Caption = vbNullString
    Call MenuDC.RestoreFont
    Set MenuDC = Nothing
  End If
  
  MenuItem.DrawExtras.Metrics(mnuMtrWidth) = Menu_MeasureItem.CX
  MenuItem.DrawExtras.Metrics(mnuMtrHeight) = Menu_MeasureItem.CY
End Function

'------------------------------------------------------------------------
' Owner Drawn Menus: Draw a menu item

Public Sub Menu_DrawItem(ByVal Menu As MenuContainer, ByVal MenuItem As MenuItem, ByVal ItemX1 As Long, ByVal ItemY1 As Long, ByVal ItemX2 As Long, ByVal ItemY2 As Long, ByVal DrawMethod As MenuDrawItemMethod, ByVal ItemState As MenuDrawItemStates, ByVal hDCItem As Long, ByVal hWndItem As Long)
  Const ERR_SRC = SRC_MOD_DRAWING & "Menu_DrawItem" & SRC_SUB
  
  '======================
  ' Variables
  
  Dim MenuDC As GDIObjects.GDIDC            ' Menu Device Context Wrapper
  Dim Brush As GDIObjects.GDIBrush          ' Painting Brush
  Dim BmpInfo As GDIObjects.Bitmap          ' Bitmap Info
  Dim ImageListType As MenuItemImages       ' Type of image list to select
  Dim ImageList As ImageListCore.ImageList  ' The current used/selected image list
  Dim MenuBitmap As IPicture                ' Actual Menu Bitmap
  Dim MenuIcon As Long                      ' Icon Image List Index
  Dim IconWidth As Long                     ' Image width
  Dim IconHeight As Long                    ' Image height
  
  Dim Pos As POINTAPI                       ' Caption position
  Dim Caption As String                     ' Caption
  Dim Bounds As RECT                        ' API Bounds rect
  
  Dim Background As Boolean                 ' Has Background?
  Dim Icon As Boolean                       ' Has Icon?
  Dim IconImage As Boolean                  ' Has Non standard Icon?
  
  Dim RadioStyle As Boolean                 ' Is Radiocheck item?
  Dim Separator As Boolean                  ' Is Separator?
  Dim Checked As Boolean                    ' Is Checked?
  Dim Default As Boolean                    ' Is Default Item?
  Dim Disabled As Boolean                   ' Is UI Disabled?
  Dim Grayed As Boolean                     ' Is Grayed?
  Dim Selected As Boolean                   ' is Selected?
  Dim HotLight As Boolean                   ' Hotlight/track state?
  
  Dim BackColor As OLE_COLOR                ' Background Color
  
  
  '======================
  ' Get Information
  
  
  ' Get information of the menu
  Checked = ((ItemState And mnuDrawStateChecked) = mnuDrawStateChecked)
  Default = ((ItemState And mnuDrawStateDefault) = mnuDrawStateDefault)
  Disabled = ((ItemState And mnuDrawStateDisabled) = mnuDrawStateDisabled)
  HotLight = ((ItemState And mnuDrawStateHotLight) = mnuDrawStateHotLight)
  Grayed = ((ItemState And mnuDrawStateGrayed) = mnuDrawStateGrayed)
  Selected = ((ItemState And mnuDrawStateSelected) = mnuDrawStateSelected)
  RadioStyle = ((MenuItem.MenuType And mnuFlagCheckRadio) = mnuFlagCheckRadio)
  Separator = ((MenuItem.MenuType And mnuFlagSeparator) = mnuFlagSeparator)
  Caption = MenuItem.Caption
  Pos.X = ItemX1
  Pos.Y = ItemY1
  
  ' Retreive object from interface pointer and attach to GDIDC object
  Set MenuDC = Menu_GetMenuDC(MenuItem, hDCItem, Default)
  
  ' Get handle of icon list
  Icon = (Checked Or RadioStyle)
  If Not Menu Is Nothing Then
    If Checked Then
      Set ImageList = Menu.DrawExtras.ImageLists(mnuImageChecked)
      ImageListType = mnuImageChecked
    ElseIf Selected Then
      Set ImageList = Menu.DrawExtras.ImageLists(mnuImageSelected)
      ImageListType = mnuImageSelected
    End If
    If ImageList Is Nothing Then
      Set ImageList = Menu.DrawExtras.ImageLists(mnuImageNormal)
      ImageListType = mnuImageNormal
    End If
  End If
  
  ' Get the size
  IconWidth = MenuItem.DrawExtras.Metrics(mnuMtrIconWidth)
  IconHeight = MenuItem.DrawExtras.Metrics(mnuMtrIconHeight)
  MenuIcon = (ItemY2 - ItemY1) - ICON_BORDER_TOP - ICON_BORDER_BOTTOM
  If IconHeight < MenuIcon Then
    If IconWidth = IconHeight Then
      IconWidth = MenuIcon
    End If
    IconHeight = MenuIcon
  End If
  MenuIcon = 0 ' Undef (it's used elsewhere for something else)
  
  
  ' Which icon to choose?
  If ImageList Is Nothing Then
    If Checked Then
      Set MenuBitmap = MenuItem.CheckedBitmap
    Else
      Set MenuBitmap = MenuItem.UnCheckedBitmap
    End If
    MenuIcon = MenuBitmap.Handle
  Else
    Set MenuBitmap = Nothing
    If Checked Then
      MenuIcon = MenuItem.DrawExtras.IconIndex(mnuImageChecked)
    ElseIf Selected Then
      MenuIcon = MenuItem.DrawExtras.IconIndex(mnuImageSelected)
    End If
    If MenuIcon = 0 Then
      MenuIcon = MenuItem.DrawExtras.IconIndex(mnuImageNormal)
    End If
  End If
  IconImage = (MenuIcon <> 0)
  Icon = (Icon Or IconImage)
  
  
  '======================
  ' Start Drawing
  
  
  ' Draw background for submenu items
  Background = Menu_DrawBackground(MenuDC, Menu.DrawExtras.Background, ItemX1, ItemY1, ItemX2, ItemY2)
  BackColor = MenuItem.DrawExtras.Colors(IIf(Selected And Not Disabled, mnuClrSelBackground, mnuClrBackground)) '' IIf(Selected And Not IsTopLevel,
  If Background Then
    If SetBkMode(hDCItem, dcBgModeTransparent) = 0 Then Call RaiseVBDLLError(ERR_SRC, ERR_FAIL_DLLCALL & "Failed to enable transparent text!")
  Else
    If SetBkColor(hDCItem, CColor(BackColor)) = 0 Then Call RaiseVBDLLError(ERR_SRC, ERR_FAIL_DLLCALL & "Failed to set background color!")
  End If
  
  ' Draw caption and selection area
  If Disabled Then
    If Separator Then
      Call Menu_DrawSeparator(hDCItem, ItemX1, ItemY1, ItemX2, ItemY2, True)
    Else
      Pos = Menu_GetTextPos(hDCItem, MenuItem, Caption, ItemX1, ItemY1, ItemX2, ItemY2, IconWidth)
      Call Menu_DrawCaption(hDCItem, MenuItem, Caption, Pos.X + 2, Pos.Y, ItemX2, ItemY2, IconWidth, dcStateDisabled)
    End If
  Else
    If Separator Then
      ' If Not IsTopLevel Then
      Call Menu_DrawSeparator(hDCItem, ItemX1, ItemY1, ItemX2, ItemY2, False)
    Else
      ' Retreive text position
      Pos = Menu_GetTextPos(hDCItem, MenuItem, Caption, ItemX1, ItemY1, ItemX2, ItemY2, IconWidth)
      If (Not Background) Or Selected Then
        Bounds.Left = ItemX1
        Bounds.Top = ItemY1
        Bounds.Bottom = ItemY2
        If Icon Then
          ' Draw icon background
          Bounds.Right = ItemX1 + IconWidth + ICON_BORDER_LEFT + ICON_BORDER_RIGHT
          Set Brush = GDIObjects.GDICreateBrush(MenuItem.DrawExtras.Colors(mnuClrBackground))
          If FillRect(hDCItem, Bounds, Brush.hBrush) = 0 Then Call RaiseVBDLLError(ERR_SRC, ERR_FAIL_DLLCALL & "Failed to draw icon background!")
          ' Draw caption background      ' IIf(Selected And Not IsTopLevel,
          Bounds.Left = Pos.X
          Bounds.Right = ItemX2
          Set Brush = GDIObjects.GDICreateBrush(BackColor)
          If FillRect(hDCItem, Bounds, Brush.hBrush) = 0 Then Call RaiseVBDLLError(ERR_SRC, ERR_FAIL_DLLCALL & "Failed to draw caption background!")
        Else
          ' Draw full caption background
          Bounds.Right = ItemX2
          Set Brush = GDIObjects.GDICreateBrush(BackColor)
          If FillRect(hDCItem, Bounds, Brush.hBrush) = 0 Then Call RaiseVBDLLError(ERR_SRC, ERR_FAIL_DLLCALL & "Failed to draw caption background!")
        End If
        Set Brush = Nothing ' Destroy it and debug easier.
      End If
      
      ' Draw the text
      ' IIf(Selected And Not IsTopLevel,
      If SetTextColor(hDCItem, CColor(MenuItem.DrawExtras.Colors(IIf(Selected, mnuClrSelText, mnuClrMenuText)))) = CLR_INVALID Then Call RaiseVBDLLError(ERR_SRC, ERR_FAIL_DLLCALL & "Failed to set text color!")
      Call Menu_DrawCaption(hDCItem, MenuItem, Caption, Pos.X + 2, Pos.Y, ItemX2, ItemY2, IconWidth)
      
'     If IsTopLevel And Selected Then
'       Bounds.Left = ItemX1
'       Bounds.Top = ItemY1
'       Bounds.Right = ItemX2
'       Bounds.Bottom = ItemY2
'       If DrawEdge(hDCItem, Bounds, dcBorderSunkenOuther, dcBorderRect) = 0 Then Call RaiseVBDLLError(ERR_SRC, ERR_FAIL_DLLCALL & "Failed to draw border!")
'     End If
    End If
  End If
  
  ' We're going to draw the icons with background now.
  If Not Separator Then
    ' Draw background and border
    If Icon Then
      If (Checked Or RadioStyle) Then
        ' Sunken border for checkboxes.
        Bounds.Left = ItemX1
        Bounds.Top = ItemY1
        Bounds.Right = ItemX1 + (ItemY2 - ItemY1)
        Bounds.Bottom = ItemY2
        If DrawEdge(hDCItem, Bounds, dcBorderSunkenOuther, dcBorderRect) = 0 Then Call RaiseVBDLLError(ERR_SRC, ERR_FAIL_DLLCALL & "Failed to draw checkbox border!")
      End If
      Bounds.Left = ItemX1 + 1
      Bounds.Top = ItemY1 + 1
      Bounds.Right = ItemX1 + IconWidth + (ICON_BORDER_LEFT + ICON_BORDER_RIGHT)
      Bounds.Bottom = ItemY2 - 1
      If (Not Selected) And (Not Disabled) And (Checked Or RadioStyle) Then
        ' Draw dilter background
        Set Brush = GDIObjects.GDICreateBrush(, GDIObjects.bshStyleBmpPattern8x8, bmpDilter.Handle)
        If FillRect(hDCItem, Bounds, Brush.hBrush) = 0 Then Call RaiseVBDLLError(ERR_SRC, ERR_FAIL_DLLCALL & "Failed to draw dilter background!")
      Else
        ' Draw flat background
        Set Brush = GDIObjects.GDICreateBrush(MenuItem.DrawExtras.Colors(mnuClrBackground))
        If FillRect(hDCItem, Bounds, Brush.hBrush) = 0 Then Call RaiseVBDLLError(ERR_SRC, ERR_FAIL_DLLCALL & "Failed to draw flat background!")
      End If
      Set Brush = Nothing
    End If
    'If (Selected And IconImage) And Not (Checked Or RadioStyle Or Disabled Or IsTopLevel) Then
    If (Selected And IconImage) And Not (Checked Or RadioStyle Or Disabled) Then
      ' Raised border, like you've seen happen with standard icons in word 97
      Bounds.Left = ItemX1
      Bounds.Top = ItemY1
      Bounds.Right = ItemX1 + IconWidth + ICON_BORDER_LEFT + ICON_BORDER_RIGHT
      Bounds.Bottom = ItemY1 + IconHeight + ICON_BORDER_TOP + ICON_BORDER_BOTTOM
      If DrawEdge(hDCItem, Bounds, dcBorderRaisedInner, dcBorderRect) = 0 Then Call RaiseVBDLLError(ERR_SRC, ERR_FAIL_DLLCALL & "Failed to draw icon border!")
    End If
    
    ' Draw icon
    If IconImage Then
      ' IIf(Not IsTopLevel, ItemX1, ItemX1 + ((ItemX2 - ItemX1) - IconWidth - (ICON_BORDER_LEFT + ICON_BORDER_RIGHT)) \ 2) + ICON_BORDER_LEFT
      Pos.X = ItemX1 + ICON_BORDER_LEFT
      Pos.Y = ItemY1 + ICON_BORDER_TOP
      If Not ImageList Is Nothing Then
        If MenuIcon >= 1 And MenuIcon <= ImageList.Images.Count Then
          If Disabled Then
            Set MenuBitmap = ImageList.Images(MenuIcon).ExtractIcon()
            If DrawState(hDCItem, 0, 0, MenuBitmap.Handle, 0, Pos.X, Pos.Y, IconWidth, IconHeight, dcStateDisabled Or IIf((MenuBitmap.Type = ImageListCore.imlTypeIcon Or MenuBitmap.Type = ImageListCore.imlTypeCursor), dcStateIcon, dcStateBitmap)) = 0 Then Call RaiseVBDLLError(ERR_SRC, ERR_FAIL_DLLCALL & "Failed to draw disabled icon!")
          Else
            Call ImageList.Images(MenuIcon).DrawToEx(hDCItem, Pos.X, Pos.Y, , , , , ImageListCore.imlDrawTransparent)
          End If
        ElseIf MenuIcon <> 0 Then
          Debug.Print "MENU [OWNERDRAW]: IconIndex out of rangle!"
        End If
      Else
        If DrawState(hDCItem, 0, 0, MenuBitmap.Handle, 0, Pos.X, Pos.Y, IconWidth, IconHeight, IIf(Disabled, dcStateDisabled, dcStateNormal) Or IIf((MenuBitmap.Type = ImageListCore.imlTypeIcon Or MenuBitmap.Type = ImageListCore.imlTypeCursor), dcStateIcon, dcStateBitmap)) = 0 Then Call RaiseVBDLLError(ERR_SRC, ERR_FAIL_DLLCALL & "Failed to draw original icon!")
      End If
    ElseIf Checked Then
      Call Menu_DrawDefaultIcon(MenuItem, MenuDC, ItemX1, ItemY1, ItemX2, ItemY2, IconWidth, IconHeight, RadioStyle)
    End If
  End If
  
  ' Restore DC
  Call MenuDC.RestorePen
  Call MenuDC.RestoreBrush
  Call MenuDC.RestoreFont
  If SetBkMode(hDCItem, dcBgModeOpaque) = 0 Then Call RaiseVBDLLError(ERR_SRC, ERR_FAIL_DLLCALL & "Failed to restore menu item fill style!")
  Set MenuDC = Nothing
End Sub


'------------------------------------------------------------------------
' Owner Drawn Menus: Get text position on item

Private Function Menu_GetTextPos(ByVal hDC As OLE_HANDLE, ByVal MenuItem As MenuItem, ByVal Text As String, ByVal ItemX1 As Long, ByVal ItemY1 As Long, ByVal ItemX2 As Long, ByVal ItemY2 As Long, ByVal IconWidth As Long) As POINTAPI
  Const ERR_SRC = SRC_MOD_DRAWING & "Menu_GetTextPos" & SRC_FUNCTION
  Dim Diff As Long
  Dim MenuHeight As Long
  Dim Bounds As RECT
  
  MenuHeight = ItemY2 - ItemY1
' If (IsTopLevel) Then MenuHeight = MenuHeight - 2 ' Allow for border
  
  ' Determine the size of the text to draw:
  Bounds.Left = ItemX1
  Bounds.Top = ItemY1
  If DrawTextEx(hDC, Text, Len(Text), Bounds, dcDrawCalcRectInstead, ByVal 0) = 0 Then Call RaiseVBDLLError(ERR_SRC, ERR_FAIL_DLLCALL & "Failed to get text position!")
  Menu_GetTextPos.X = Bounds.Left
  Menu_GetTextPos.Y = Bounds.Top
  
  ' We want to centre the text vertically:
  Diff = MenuHeight - (Bounds.Bottom - Menu_GetTextPos.Y)
  If (Diff > 0) Then Menu_GetTextPos.Y = Menu_GetTextPos.Y + Diff \ 2
  
  ' Now move the left position of the text
  ' across to accommodate icon/selection rectangle:
' If (IsTopLevel) Then
'   If (MenuItem.UnCheckedBitmap.Handle <> 0 Or MenuItem.CheckedBitmap.Handle <> 0) Then
'     Menu_GetTextPos.X = Menu_GetTextPos.X + IconWidth + ICON_BORDER_LEFT + ICON_BORDER_RIGHT
'   Else
'     Menu_GetTextPos.X = Menu_GetTextPos.X + ICON_BORDER_LEFT + ICON_BORDER_RIGHT
'   End If
' Else
  Menu_GetTextPos.X = Menu_GetTextPos.X + IconWidth + ICON_BORDER_LEFT + ICON_BORDER_RIGHT + 1
' End If
End Function

'------------------------------------------------------------------------
' Owner Drawn Menus: Draw the menu caption

Private Sub Menu_DrawCaption(ByVal hDC As OLE_HANDLE, ByVal MenuItem As MenuItem, ByVal Caption As String, ByVal ItemX1 As Long, ByVal ItemY1 As Long, ByVal ItemX2 As Long, ByVal ItemY2 As Long, ByVal IconWidth As Long, Optional ByVal State As DCStateFlags)
  Const ERR_SRC = SRC_MOD_DRAWING & "Menu_DrawCaption" & SRC_SUB
  Dim Pos As Long
  Dim ShortCut As String
  
  Do
    Pos = InStr(Pos + 1, Caption, vbTab)
    If Pos Then ShortCut = Mid(Caption, Pos + 1)
  Loop While Pos
  If Len(ShortCut) Then
    Caption = Left(Caption, Len(Caption) - Len(ShortCut) - 1)
    Pos = IconWidth + 4
    If DrawStateString(hDC, 0, 0, ShortCut, Len(ShortCut), 0, ItemY1, ItemX2 - Pos, ItemY2 - ItemY1, State Or dcStateRight Or dcStateText) = 0 Then Call RaiseVBDLLError(ERR_SRC, ERR_FAIL_DLLCALL & "Failed to draw caption shortcut!")
  End If
  If DrawStateString(hDC, 0, 0, Caption, Len(Caption), ItemX1, ItemY1, ItemX2 - ItemX1, ItemY2 - ItemY1, State Or dcStatePrefixText) = 0 Then Call RaiseVBDLLError(ERR_SRC, ERR_FAIL_DLLCALL & "Failed to draw caption!")
End Sub

'------------------------------------------------------------------------
' Owner Drawn Menus: Draw a separator

Private Sub Menu_DrawSeparator(ByVal hDC As OLE_HANDLE, ByVal ItemX1 As Long, ByVal ItemY1 As Long, ByVal ItemX2 As Long, ByVal ItemY2 As Long, ByVal Disabled As Boolean)
  Const ERR_SRC = SRC_MOD_DRAWING & "Menu_DrawSeparator" & SRC_SUB
  Dim Bounds As RECT
  Bounds.Left = ItemX1 + MENU_SEP_PADDING
  Bounds.Top = ItemY1 + (0.5 * (ItemY2 - ItemY1)) - 1
  Bounds.Right = ItemX2 - MENU_SEP_PADDING
  Bounds.Bottom = ItemY1 + (0.5 * (ItemY2 - ItemY1))
  If DrawEdge(hDC, Bounds, dcBorderEtched, dcBorderTop Or IIf(Disabled, 0, dcBorderBottom)) = 0 Then Call RaiseVBDLLError(ERR_SRC, ERR_FAIL_DLLCALL & "Failed to draw separator line!")
End Sub

'------------------------------------------------------------------------
' Owner Drawn Menus: Draw the background

Private Function Menu_DrawBackground(ByVal MenuDC As GDIObjects.GDIDC, ByVal Background As IPicture, ByVal ItemX1 As Long, ByVal ItemY1 As Long, ByVal ItemX2 As Long, ByVal ItemY2 As Long) As Boolean
  Const ERR_SRC = SRC_MOD_DRAWING & "Menu_DrawBackground" & SRC_FUNCTION
' If Not IsTopLevel Then
  If Background.Handle <> 0 Then
    Dim hOldDC As OLE_HANDLE
    If Background.CurDC = 0 Then
      Dim dcBack As GDIObjects.GDIDC
      Dim BackInfo As GDIObjects.Bitmap
      If GetObject(Background.Handle, LenB(BackInfo), BackInfo) = 0 Then Call RaiseVBDLLError(ERR_SRC, ERR_FAIL_DLLCALL & "Failed to get background bitmap info!")
      Set dcBack = GDIObjects.GDICreateDCC(, , (BackInfo.bmBitsPixel = 1))
      Call dcBack.SelectGDIObject(Background.Handle)
      Call TileArea(MenuDC.hDC, ItemX1, ItemY1, ItemX2, ItemY2, dcBack.hDC, BackInfo.bmWidth, BackInfo.bmHeight)
      Call dcBack.RestoreBitmap
      Set dcBack = Nothing
    Else
      Call TileArea(MenuDC.hDC, ItemX1, ItemY1, ItemX2, ItemY2, Background.CurDC, BackInfo.bmWidth, BackInfo.bmHeight)
    End If
    Menu_DrawBackground = True
  End If
' End If
End Function

Private Sub TileArea(ByVal hDC As OLE_HANDLE, ByVal X1 As Long, ByVal Y1 As Long, ByVal X2 As Long, ByVal Y2 As Long, ByVal hSrcDC As OLE_HANDLE, ByVal SrcWidth As Long, ByVal SrcHeight As Long, Optional ByVal RasterOpCode As DCRasterOperations = dcBitSrcCopy)
  Dim SrcX As Long
  Dim SrcY As Long
  Dim SrcStartX As Long
  Dim SrcStartY As Long
  Dim SrcStartWidth As Long
  Dim SrcStartHeight As Long
  Dim DstX As Long
  Dim DstY As Long
  Dim DstWidth As Long
  Dim DstHeight As Long
  Dim ObjType As GDIObjects.GDIObjectTypes
  
  ObjType = GDIObjects.GDIObjectType(hSrcDC)
  If (ObjType <> gdiObjDC And ObjType <> gdiObjMemoryDC And ObjType <> gdiObjMetaDC And ObjType <> gdiObjEnhancedMetaDC) Then Error 5
  
  SrcStartX = (X1 Mod SrcWidth)
  SrcStartY = (Y1 Mod SrcHeight)
  SrcStartWidth = (SrcWidth - SrcStartX)
  SrcStartHeight = (SrcHeight - SrcStartY)
  SrcX = SrcStartX
  SrcY = SrcStartY
  
  DstY = Y1
  DstHeight = SrcStartHeight
  
  Do While DstY < Y2
    If (DstY + DstHeight) > Y2 Then DstHeight = Y2 - DstY
    DstWidth = SrcStartWidth
    DstX = X1
    SrcX = SrcStartX
    If (DstHeight > (Y2 - Y1)) Then DstHeight = (Y2 - Y1)
    Do While DstX < X2
      If (DstX + DstWidth) > X2 Then
        DstWidth = X2 - DstX
        If (DstWidth = 0) Then DstWidth = 4
      End If
      If (DstWidth > (X2 - X1)) Then DstWidth = (X2 - X1)
      If BitBlt(hDC, DstX, DstY, DstWidth, DstHeight, hSrcDC, SrcX, SrcY, RasterOpCode) = 0 Then Error 5
      DstX = DstX + DstWidth
      SrcX = 0
      DstWidth = SrcWidth
    Loop
    DstY = DstY + DstHeight
    SrcY = 0
    DstHeight = SrcHeight
  Loop
End Sub


'------------------------------------------------------------------------
' Owner Drawn Menus: Draw a default icon (checkmark or radiomark)

Private Sub Menu_DrawDefaultIcon(ByVal MenuItem As MenuItem, ByVal MenuDC As GDIObjects.GDIDC, ByVal ItemX1 As Long, ByVal ItemY1 As Long, ByVal ItemX2 As Long, ByVal ItemY2 As Long, ByVal IconWidth As Long, ByVal IconHeight As Long, ByVal RadioStyle As Boolean)
  Const ERR_SRC = SRC_MOD_DRAWING & "Menu_DrawDefaultIcon" & SRC_SUB
  Dim Pen As GDIObjects.GDIPen
  Dim Brush As GDIObjects.GDIBrush
  Dim PosIcon As POINTAPI
  Dim Pos As POINTAPI
  Dim hDC As OLE_HANDLE
  
  hDC = MenuDC.hDC
  Set Pen = GDIObjects.GDICreatePen(vbWhite)
  
  ' Calculate check mark position
' If Not IsTopLevel Then
'   PosIcon.X = ItemX1
' Else
'   PosIcon.X = ((ItemX2 - ItemX1) - (IconWidth + ICON_BORDER_LEFT + ICON_BORDER_RIGHT)) \ 2
' End If
  If RadioStyle Then
    ' Draw radio checkmark
    Pos.X = Round((IconWidth / 2) - (ICON_RADIO_SIZE / 2))
    Pos.Y = Round((IconHeight / 2) - (ICON_RADIO_SIZE / 2))
    
    PosIcon.X = ICON_BORDER_LEFT + ItemX1 + Pos.X + 1
    PosIcon.Y = ICON_BORDER_TOP + ItemY1 + Pos.Y
    
    ' Draw white shadow circle
    Set MenuDC.SelPen = Pen
    If Arc(hDC, PosIcon.X, PosIcon.Y + 1, PosIcon.X + Pos.X + 1, PosIcon.Y + Pos.Y + 2, 0, 0, 0, 0) = 0 Then Call RaiseVBDLLError(ERR_SRC, ERR_FAIL_DLLCALL & "Failed to draw shadow circle!")
    Call MenuDC.RestorePen
    
    ' Draw actual checkmark
    Set Brush = GDIObjects.GDICreateBrush(vbBlack)
    Set MenuDC.SelBrush = Brush
    If Ellipse(hDC, PosIcon.X, PosIcon.Y, PosIcon.X + Pos.X + 1, PosIcon.Y + Pos.Y + 1) = 0 Then Call RaiseVBDLLError(ERR_SRC, ERR_FAIL_DLLCALL & "Failed to draw black circle!")
    Call MenuDC.RestoreBrush
    Set Brush = Nothing
  Else
    ' Draw normal checkmark
    Pos.X = ItemX1 + Round(IconWidth / 2) + ICON_BORDER_LEFT
    Pos.Y = ItemY1 + Round(IconHeight / 2) + ICON_BORDER_TOP
    
    Set MenuDC.SelPen = Pen
    If MoveToEx(hDC, Pos.X - 4, Pos.Y, ByVal 0) = 0 Then Call RaiseVBDLLError(ERR_SRC, ERR_FAIL_MOVETO)
    If LineTo(hDC, Pos.X - 4, Pos.Y + 1) = 0 Then Call RaiseVBDLLError(ERR_SRC, ERR_FAIL_LINETO)
    If LineTo(hDC, Pos.X - 1, Pos.Y + 4) = 0 Then Call RaiseVBDLLError(ERR_SRC, ERR_FAIL_LINETO)
    If LineTo(hDC, Pos.X + 5, Pos.Y - 2) = 0 Then Call RaiseVBDLLError(ERR_SRC, ERR_FAIL_LINETO)
    If SetPixel(hDC, Pos.X + 4, Pos.Y - 2, vbWhite) = 0 Then Call RaiseVBDLLError(ERR_SRC, ERR_FAIL_DLLCALL & "Failed to draw a pixel!")
    Call MenuDC.RestorePen
    
    Set Pen = GDIObjects.GDICreatePen(vbBlack)
    Set MenuDC.SelPen = Pen
    If MoveToEx(hDC, Pos.X - 3, Pos.Y, ByVal 0) = 0 Then Call RaiseVBDLLError(ERR_SRC, ERR_FAIL_MOVETO)
    If LineTo(hDC, Pos.X, Pos.Y + 3) = 0 Then Call RaiseVBDLLError(49, ERR_SRC, ERR_FAIL_LINETO)
    If MoveToEx(hDC, Pos.X - 3, Pos.Y + 1, ByVal 0) = 0 Then Call RaiseVBDLLError(ERR_SRC, ERR_FAIL_MOVETO)
    If LineTo(hDC, Pos.X, Pos.Y + 4) = 0 Then Call RaiseVBDLLError(ERR_SRC, ERR_FAIL_LINETO)
    If MoveToEx(hDC, Pos.X, Pos.Y + 1, ByVal 0) = 0 Then Call RaiseVBDLLError(ERR_SRC, ERR_FAIL_MOVETO)
    If LineTo(hDC, Pos.X + 4, Pos.Y - 3) = 0 Then Call RaiseVBDLLError(ERR_SRC, ERR_FAIL_LINETO)
    If MoveToEx(hDC, Pos.X, Pos.Y + 2, ByVal 0) = 0 Then Call RaiseVBDLLError(ERR_SRC, ERR_FAIL_MOVETO)
    If LineTo(hDC, Pos.X + 4, Pos.Y - 2) = 0 Then Call RaiseVBDLLError(ERR_SRC, ERR_FAIL_LINETO)
    Call MenuDC.RestorePen
  End If
  Set Pen = Nothing ' Destroy and debug easier
End Sub

'------------------------------------------------------------------------
' Owner Drawn Menus: Retreive the menu font

Private Function Menu_GetMenuFont(ByVal MenuItem As MenuItem, ByVal Default As Boolean) As GDIObjects.GDIFont
  If Default Then
    Set Menu_GetMenuFont = MenuItem.DrawExtras.DefaultFont
  Else
    Set Menu_GetMenuFont = MenuItem.DrawExtras.NormalFont
  End If
End Function

'------------------------------------------------------------------------
' Owner Drawn Menus: Get the menu item class from drawitem structure

Private Function Menu_GetMenuItem(ByVal ItemData As Long) As MenuItem
  On Error Resume Next
    Set Menu_GetMenuItem = GetObjFromPtr(-ItemData)
    If Err.Number Or ObjPtr(Menu_GetMenuItem) = 0 Then Set Menu_GetMenuItem = Nothing
  On Error GoTo 0
End Function

'------------------------------------------------------------------------
' Owner Drawn Menus: Get a GDIDC object for easier drawing to menu item

Private Function Menu_GetMenuDC(ByVal MenuItem As MenuItem, ByVal hDCItem As OLE_HANDLE, ByVal Default As Boolean) As GDIObjects.GDIDC
  Const ERR_SRC = SRC_MOD_DRAWING & "Menu_GetMenuDC" & SRC_FUNCTION
  Set Menu_GetMenuDC = GDIObjects.GDIAttachDC(hDCItem, False) ' Never destroy a menu dc!!!
  Set Menu_GetMenuDC.SelFont = Menu_GetMenuFont(MenuItem, Default)
End Function

'------------------------------------------------------------------------
' Owner Drawn Menus: Get the default menu font

Public Function GetDefaultMenuFont(Optional ByVal ForceRefresh As Boolean, Optional ByVal MenuIsDefault As Boolean) As GDIFont
  Dim hFont As OLE_HANDLE
  Dim NCM As NONCLIENTMETRICS
  Dim Font As GDIObjects.GDIFont
  
  If CurDefaultFont Is Nothing Then Set CurDefaultFont = New GDIObjects.GDIFont
  If CurDefaultFontBold Is Nothing Then Set CurDefaultFontBold = New GDIObjects.GDIFont
  
  If MenuIsDefault Then
    If ForceRefresh Or CurDefaultFontBold.hFont = 0 Then
      NCM.cbSize = LenB(NCM)
      If SystemParametersInfo(SPI_GETNONCLIENTMETRICS, 0, NCM, 0) = 0 Then Error 47
      NCM.lfMenuFont.lfWeight = IIf(NCM.lfMenuFont.lfWeight + 300 <= GDIObjects.fntWeightMax, NCM.lfMenuFont.lfWeight + 300, GDIObjects.fntWeightMax)
      hFont = CreateFontIndirectNM(NCM.lfMenuFont)
      If hFont = 0 Then Error 47
      Set Font = GDIObjects.GDIAttachFont(hFont)
      If Font.hFont = 0 Then Error 47
      Set CurDefaultFontBold = Font
    End If
    Set GetDefaultMenuFont = CurDefaultFontBold
    CurDefaultFontBold.OwnsHandle = False
  Else
    If ForceRefresh Or CurDefaultFont.hFont = 0 Then
      NCM.cbSize = LenB(NCM)
      If SystemParametersInfo(SPI_GETNONCLIENTMETRICS, 0, NCM, 0) = 0 Then Error 47
      hFont = CreateFontIndirectNM(NCM.lfMenuFont)
      If hFont = 0 Then Error 47
      Set Font = GDIObjects.GDIAttachFont(hFont)
      Set CurDefaultFont = Font
    End If
    Set GetDefaultMenuFont = CurDefaultFont
    CurDefaultFont.OwnsHandle = False
  End If
End Function


'------------------------------------------------------------------------

